Introduction
API endpoint
https://<tenant>.staff.cloud/api/v1/
The Staffcloud API is organized around REST. Our API has predictable, resource-oriented URLs, and uses HTTP response codes to indicate API errors. We use built-in HTTP features, like HTTP authentication and HTTP verbs, which are understood by off-the-shelf HTTP clients.
We support cross-origin resource sharing, allowing you to interact securely with our API from a client-side web application (though you should never expose your secret API key in any public website's client-side code). By default JSON is returned by all API responses, including errors.
All API URLs listed in this documentation are relative to the API endpoint. For example, the GET /employees/1 API call
is reachable at https://<tenant>.staff.cloud/api/v1/employees/1. Parameters should be sent in URL escaped
format. All API requests must be made over HTTPS. Calls made over plain HTTP will fail. API requests without
authentication will also fail.
Libraries
Official libraries for the Staffcloud API will be available in several languages. Until they are released, a regular, language specific REST client may be used.
Versioning
Versioning helps us iterate faster and prevents invalid requests from hitting updated endpoints. It also helps smooth over any major API version transitions as we can continue to offer old API versions for a period of time. We are keeping the version in the URL to ensure browser explorability of the resources across versions.
Resources
The key principles of REST involve separating an API into logical resources. So what do we call resources? They are
nouns that make sense from the perspective of the API consumer. For example, our API provides resources such as
employees, events, projects, contacts and others.
Fields
A resource has many fields. Since it is easier to read, all field names (as well as the resource names) are written in snake_case. Every field has exactly one data type according to the JSON Schema definition.
Dynamic fields
A core concept of Staffcloud are the fully configurable entities. It is possible to manage most of the fields of most of the entities, i.e. it's possible that an employee of tenant X contains entirely different fields than an employee of tenant Y.
However, some of the dynamic fields are preexisting and linked to a given functionality. They can't be deleted. Since these fields and their intended behavior may also be relevant for an API consumer, they are given human readable names and they are listed in the particular resource documentations.
All other (user generated) dynamic fields are given a generic name like dynamic_field_50 where 50 refers to the ID
of the related attribute. They are not included in the API documentation. To retrieve a list of all dynamic fields for
a resource, you may either use the forms resource or perform a simple GET request to the desired
resource.
Authentication
Example request
$ curl https://<tenant>.staff.cloud/api/v1/ \
-H "Authorization: Bearer <ACCESS_TOKEN>"
Our RESTful API is stateless, meaning that the authentication request does not depend on cookies or sessions.
For authentication we are using JSON Web Tokens. Each request must provide an
Authorization header containing a Bearer token.
Since the API also supports JSONP and a JSONP request can't contain custom headers, a special query parameter
authorization_bearer is supported as well.
Generating tokens
A tenant can have multiple API users.
API users and tokens are managed in the Office.
Privileges
There is no granular privilege control for API users except a ready-only state which is preventing a user from calling
POST, PUT and DELETE actions.
Apart from that, an API user has access to all resources of its tenant, considering the available modules, addons, etc.
Actions
RESTful principles provide strategies to handle CRUD actions using HTTP methods mapped as follows:
GET /employees- Retrieves a list of employeesGET /employees/12- Retrieves a specific employeePOST /employees- Creates a new employeePUT /employees/12- Updates employee #12DELETE /employees/12- Deletes employee #12
In case of a POST that resulted in a creation, a Location header that points to the URL of the new resource will be
included in the response.
Our API does not support the PATCH HTTP verb, but only PUT which may accept only partial updates.
Overriding the HTTP method
Some HTTP clients can only work with simple GET and POST requests. To increase accessibility to these limited clients,
the API supports a request header X-HTTP-Method-Override with a string value containing one of PUT or DELETE.
Note that the override header is only accepted on POST requests. GET requests must never change data!
Special actions
If an action doesn't fit in the CRUD operations set, so called special actions will be available for the particular resources. These special actions will be documented separately in the resource documentation sections.
Relations
Example request
$ curl https://<tenant>.staff.cloud/api/v1/projects/12 \
-H "Authorization: Bearer <ACCESS_TOKEN>"
Example response
{
"id" : 12,
"name" : "My project",
"date" : "2015-01-01",
"client" : {
"id" : 330,
"name" : "Sample Inc.",
"location" : "Anywhere"
},
"events" : [
{
"id" : 445,
"name" : "My event"
},
{
"id" : 446,
"name" : "Another event"
}
],
"locations" : [
{
"id" : 33,
"name" : "A location"
},
{
"id" : 42,
"name" : "Another location"
}
]
}
Example request
$ curl https://<tenant>.staff.cloud/api/v1/projects/12?embed=client.id,client.name,events \
-H "Authorization: Bearer <ACCESS_TOKEN>"
Example response
{
"id" : 12,
"name" : "My project",
"date" : "2015-01-01",
"client" : {
"id" : 330,
"name" : "Sample Inc."
},
"events" : [
{
"id" : 445,
"name" : "My event"
},
{
"id" : 446,
"name" : "Another event"
}
]
}
For resources that are related to other resources or only exist as children of such, RESTful principles provide useful guidance. An example of this would be as the following:
A form in Staffcloud contains a number of attributes. These attributes can be logically mapped to the /forms
endpoint as follows:
GET /forms/12/attributes- Retrieves list of attributes for form #12GET /forms/12/attributes/5- Retrieves attribute #5 for form #12POST /forms/12/attributes- Creates a new attribute in form #12PUT /forms/12/attributes/5- Updates attribute #5 for form #12DELETE /forms/12/attributes/5- Deletes attribute #5 for form #12
For providing information about relations and providing access to them, we will include identifiers (foreign keys) in the result sets. The API consumer will then have to hit the child relation's endpoint.
However, if the relation is commonly requested alongside the resource, the API is offering the functionality to
automatically embed the relation's representation and avoid the second hit to the API. In this case, embed is a query
parameter having a comma separated list of fields to be embedded. Dot-notation may be used to refer to sub-fields. Note
that the dot notation is optional. If a sub-resource is requested without specifying fields, the full relation resource
will be returned.
Filtering, searching and sorting
Complex result filters, sorting and advanced searching (when restricted to a single type of resource) can all be easily achieved by using query parameters on top of the base URL. Let's look at these in more detail:
Filtering
Use an unique query parameter for each field that implements filtering. For example, when requesting a list of employees
from the /employees endpoint, you may want to limit these to only those having state active. This could be
accomplished with a request like GET /employees?state=1. Here, state is a query parameter that implements a filter.
The filters supports expressions and operators like this:
| Name | Expression | Example |
|---|---|---|
| Like (case insensitive) | =~ | ?name=~john |
| Equals (case sensitive) | = | ?name=john |
| Not equals | =- | ?name=-john |
| Less than | =< | ?age=<5 |
| Greater than | => | ?age=>5 |
| Contains | =... | ?name=doe |
| Not contains | =-... | ?name=-doe |
| Starts with | =*... | ?name=*john |
| Ends with | =...* | ?name=doe* |
| null | =null | ?name=null |
| not null | =-null | ?name=-null |
| empty string | = | ?name= |
| not empty string | =- | ?name=- |
| And | Use multiple filters | ?count[]=>2&count[]=<5 |
| Or | =...,... | ?name=john,george ?count=2,<2,>5 |
All of these expressions and operators may be combined as far as possible. Reserved characters for expressions must be escaped with a backslash if not contemplated as such.
Limiting returned fields
The API consumer doesn't always need the full representation of a resource.
The fields query parameter accepts a comma separated list of fields to include. A request like this will limit the
fields returned for employees:
GET /employees?fields=id,firstname,lastname,age
Sorting
Similar to filtering, a generic parameter sort is used to describe sorting rules.
It accepts a list of comma separated fields, each with a possible negative prefix to imply descending sort order. By default, if no prefix is specified, the field will be used to sort results in ascending order. Let's look at some examples:
GET /employees?sort=+age- Retrieves a list of employees in ascending order of age.GET /employees?sort=-age,name- Retrieves a list of employees in descending order of age. Within a specific age, employees are ordered ascending by name
Aliases for common queries
To make the API experience more pleasant for basic consumers, there are sets of conditions (templates) packed into easily accessible RESTful paths.
For example, the query GET /events?fields=name,start_time,end_time&state=1&date=2001-01-01&sort=name,-start_time
could be packaged up as GET /events/today.
Similar to special actions, all aliases will be documented separately in the resource documentation sections.
Response format
Though JSON is the de-facto standard for RESTful API's today, our API supports multiple return formats.
To ensure browser explorability, the format can be passed in the URL. Therefore you may just append the format as a file extension to the endpoint URL:
GET /employees/12.json- Retrieves employee #12 in JSON format.GET /forms/12/attributes.xml?sort=name- Retrieves a list of attributes for form #12 sorted by name in XML format.
For the moment only JSON and XML are supported, while JSON is used as the default format. A content type header in compliance with RFC 6838 is sent according to the response format.
JSON specific features
JSON return values are always pretty printed.
Envelopes
JSONP envelope
callback_function({
status_code: 200,
additional_header: "...",
response: {
... actual JSON response body ...
}
})
By default, a JSON API response is not wrapped in an envelope.
If you need to use cross domain requests over JSONP you may use the additional query parameter callback containing the
name of the desired callback function. Now the API will switch to a full envelope mode where it always responds with a
200 HTTP status code and passes the real status code in the JSON payload. Any additional HTTP headers that would have
been passed alongside the response will be mapped to JSON fields.
Similarly, to support limited HTTP clients, a special query parameter envelope=true that will trigger full
enveloping is supported.
Compression
All responses are compressed using GZIP, a corresponding Content-Encoding header is always included in the response.
Encoding / formats
All returned data is UTF-8 encoded. Dates, times and other formatable types are returned in consistent, common formats.
Input format
In contrast to the responses, the API only accepts JSON as format for input values used for POST and PUT actions.
An Accept-Encoding header is sent with every response to inform the client about the accepted format. If the API
receives malformed data, a 415 error code will be sent.
File uploads
Example file upload
POSTrequest. Please note that theContent-TypeandX-File-NameandX-File-Visibilityheaders are optional. TheX-File-Visibilityheader is used to (optionally) set the visibility of the file. Possible values are 'private' and 'public'. Default is 'private'
curl -X POST https://<tenant>.staff.cloud/api/v1/files \
-H "Authorization: Bearer <ACCESS_TOKEN>" \
-H "Content-Type: image/jpeg" \
-H "X-File-Name: filename.jpg" \
-H "X-File-Visibility: private" \
-d "@/path/to/filename.jpg"
Example response
{
"id": 8,
"path": "9f1d1d056e86af3b542453521ea7691",
"name": "text_58ac754s1cb2234.80345007.plain-charset-UTF-8",
"mime": "text/plain;charset=UTF-8",
"status": 0,
"user_id": 54
}
File uploads are a bit harder to implement in a pure REST manner so the file upload action is documented here although it is part of the files resource.
A file upload request looks like this:
POST /files
and the body of the request should contain the file content (binary data)
The platform will autodetect the file type and also generate a sensible and unique name for the folder/file.
Should you however want to specify the filename or the mime type for the file you can optionally do this by specifying the following headers:
X-File-Name- to specify a file name for the uploaded fileContent-Type- to specify a mime type for the uploaded file
The response will be the stored file resource. You can see an example on the right.
Rate limiting
To prevent abuse, we are rate limiting our API. RFC 6585 introduced a HTTP status code 429 Too Many Requests to accommodate this. In order to notify the API consumer about the current limits, the following headers will be sent:
X-Rate-Limit-Limit- The number of allowed requests in the current period.X-Rate-Limit-Remaining- The number of remaining requests in the current period.X-Rate-Limit-Reset- The number of seconds left in the current period.
Caching
The API is using an caching mechanism called ETag. The response will contain an ETag header which contains a hash of the representation sent. The value of the header will change whenever the output representation changes.
If an inbound HTTP request contains a If-None-Match header with an matching ETag value, the API will return a
304 Not Modified status code instead of the output representation of the resource.
HTTP status codes
| Status Code | Description |
|---|---|
| 200 OK | Response to a successful GET, PUT or DELETE. Can also be returned for a POST that doesn't result in a creation. |
| 201 Created | Response to a POST that results in a creation. It is combined with a Location header pointing to the location of the new resource. |
| 204 No Content | Response to a successful request that won't be returning a body (like a DELETE request). |
| 304 Not Modified | Used when HTTP caching headers are used. |
| 400 Bad Request | The request is malformed, such as if the body does not parse. |
| 401 Unauthorized | When no or invalid authentication details are provided. |
| 403 Forbidden | When authentication succeeded but authenticated user doesn't have access to the resource. |
| 404 Not Found | When a non-existent resource is requested. |
| 405 Method Not Allowed | When an HTTP method is being requested that isn't allowed for the authenticated user. |
| 410 Gone | Indicates that the resource at this end point is no longer available. |
| 415 Unsupported Media Type | If incorrect content type was provided as part of the request. |
| 422 Unprocessable Entity | Used for validation errors. |
| 429 Too Many Requests | When a request is rejected due to rate limiting. |
| 500 Internal Server Error | Something unexpected happened. |
| 503 Service Unavailable | The API is not available at the moment. |
Errors
Example error response
{
"code" : "field_deleted",
"message" : "Field not available",
"description" : "The requested field has been deleted."
}
Example validation error response for
PUTandPOSTrequests
{
"code" : "validation_failed",
"message" : "Validation Failed",
"errors" : [
{
"code" : "invalid_character",
"field" : "first_name",
"message" : "First name must not contain have special characters"
},
{
"code" : "not_empty",
"field" : "password",
"message" : "Password cannot be blank"
}
]
}
In case of errors, the API provides useful responses which explain the errors thrown.
Resources
Assignment contract
Schema
Assignment-contract schema
{
"properties": {
"assignment_id": {
"label": "Assignment Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"document_template_id": {
"label": "Document Template Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"planner_id": {
"label": "Planner Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"type": {
"label": "Document Type",
"editable": false,
"type": "string",
"format": "int"
},
"file": {
"label": "Document file",
"editable": false,
"type": "string"
},
"data": {
"label": "Document data",
"editable": false,
"type": "array"
},
"created_at": {
"label": "Created at Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"created_at_date": {
"label": "Created at Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "created_at"
},
"created_at_time": {
"label": "Created at Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "created_at"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| assignment_id | Read Only | foreignKey (int) | Assignment Id |
| document_template_id | Read Only | foreignKey (int) | Document Template Id |
| planner_id | Read Only | foreignKey (int) | Planner Id |
| type | Read Only | string (int) | Document Type |
| file | Read Only | string | Document file |
| data | Read Only | array | Document data |
| created_at | Read Only | string (date-time) | Created at Date-Time |
| created_at_date | Read Only | string (date) | Created at Date-Time Date |
| created_at_time | Read Only | string (time) | Created at Date-Time Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| contractAssignment | assignments | assignment-contract.assignment_id |
Actions
| Request | Description |
|---|---|
GET /assignment-contract | Resource listing |
GET /assignment-contract/<id> | Resource read |
POST /assignment-contract | Resource create |
PUT /assignment-contract/<id> | Resource update |
DELETE /assignment-contract/<id> | Resource delete |
GET /assignment-contract/<id>/file | Note: this action is deprecated. Get the contract file of an assignment. |
Assignment employment reports
Schema
Assignment-employment-reports schema
{
"properties": {
"assignment_id": {
"label": "Assignment Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"planner_id": {
"label": "Planner Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"type": {
"label": "Report Type",
"editable": false,
"type": "int",
"format": "int"
},
"data": {
"label": "Document data",
"editable": false,
"type": "array"
},
"created_at": {
"label": "Created at Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"updated_at": {
"label": "Updated at Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"created_at_date": {
"label": "Created at Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "created_at"
},
"created_at_time": {
"label": "Created at Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "created_at"
},
"updated_at_date": {
"label": "Updated at Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "updated_at"
},
"updated_at_time": {
"label": "Updated at Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "updated_at"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| assignment_id | Read Only | foreignKey (int) | Assignment Id |
| planner_id | Read Only | foreignKey (int) | Planner Id |
| type | Read Only | int (int) | Report Type |
| data | Read Only | array | Document data |
| created_at | Read Only | string (date-time) | Created at Date-Time |
| updated_at | Read Only | string (date-time) | Updated at Date-Time |
| created_at_date | Read Only | string (date) | Created at Date-Time Date |
| created_at_time | Read Only | string (time) | Created at Date-Time Time |
| updated_at_date | Read Only | string (date) | Updated at Date-Time Date |
| updated_at_time | Read Only | string (time) | Updated at Date-Time Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| reportAssignment | assignments | assignment-employment-reports.assignment_id |
Actions
| Request | Description |
|---|---|
GET /assignment-employment-reports | Resource listing |
GET /assignment-employment-reports/<id> | Resource read |
POST /assignment-employment-reports | Resource create |
PUT /assignment-employment-reports/<id> | Resource update |
DELETE /assignment-employment-reports/<id> | Resource delete |
Assignment wages
Schema
Assignment-wages schema
{
"properties": {
"assignment_id": {
"label": "Assignment ID",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"wage_profile_id": {
"label": "Profile Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"type": {
"label": "Payment Type",
"editable": false,
"type": "string",
"format": "int"
},
"payable_amount": {
"label": "Payable Amount",
"editable": false,
"type": "float"
},
"base_value": {
"label": "Base Value",
"editable": false,
"type": "float"
},
"factor": {
"label": "Factor",
"editable": false,
"type": "float",
"format": "int"
},
"is_disabled": {
"label": "Disabled",
"editable": false,
"type": "integer",
"format": "bool"
},
"is_valid": {
"label": "Valid",
"editable": false,
"type": "integer",
"format": "bool"
},
"wage_type": {
"label": "Wage Type",
"editable": false,
"type": "object",
"flatten": true
},
"wage_type_value": {
"label": "Wage Type Value",
"editable": false,
"type": "object",
"flatten": true
},
"wage_type.name": {
"label": "Wage Type Name",
"editable": false,
"type": "string",
"format": "string"
},
"wage_type.external_id": {
"label": "Wage Type External ID",
"editable": false,
"type": "string"
},
"wage_type.external_cost": {
"label": "Wage Type External cost",
"editable": false,
"format": "string"
},
"wage_type.currency_format": {
"label": "Wage Type Currency Format",
"editable": false,
"type": "string"
},
"wage_type_value.unit": {
"label": "Wage Type Unit",
"format": "string",
"editable": false,
"type": "string"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| assignment_id | Read Only | foreignKey (int) | Assignment ID |
| wage_profile_id | Read Only | foreignKey (int) | Profile Id |
| type | Read Only | string (int) | Payment Type |
| payable_amount | Read Only | float | Payable Amount |
| base_value | Read Only | float | Base Value |
| factor | Read Only | float (int) | Factor |
| is_disabled | Read Only | integer (bool) | Disabled |
| is_valid | Read Only | integer (bool) | Valid |
| wage_type | Read Only | object | Wage Type |
| wage_type_value | Read Only | object | Wage Type Value |
| wage_type.name | Read Only | string (string) | Wage Type Name |
| wage_type.external_id | Read Only | string | Wage Type External ID |
| wage_type.external_cost | Read Only | (string) | Wage Type External cost |
| wage_type.currency_format | Read Only | string | Wage Type Currency Format |
| wage_type_value.unit | Read Only | string (string) | Wage Type Unit |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| wageAssignment | assignments | assignment-wages.assignment_id | |
| wageProfile | wage-profiles | assignment-wages.wage_profile_id |
Actions
| Request | Description |
|---|---|
GET /assignment-wages | Resource listing |
GET /assignment-wages/<id> | Resource read |
POST /assignment-wages | Resource create |
PUT /assignment-wages/<id> | Resource update |
DELETE /assignment-wages/<id> | Resource delete |
Assignments
Describes event assignments. An event function that has been assigned to an employee.
Schema
Assignments schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"employee_id": {
"label": "Employee Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"event_function_id": {
"label": "Event Function Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"event_id": {
"label": "Event Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"project_id": {
"label": "Project Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"client_id": {
"label": "Client Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"contact_id": {
"label": "Contact Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"planner_id": {
"label": "Planner Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"location_id": {
"label": "Location Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"wage_profile_id": {
"label": "Assignment Wage Profile Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"event_function.id": {
"label": "Event Function ID",
"editable": false,
"description": "ID of the event function",
"type": "int"
},
"event_function.function_id": {
"label": "Function ID",
"editable": false,
"description": "ID of the event function",
"type": "int"
},
"event_function.description": {
"label": "Event Function Description",
"editable": false,
"description": "Short description of the event function referenced by the assignment.",
"type": "string"
},
"event_function.location.name": {
"label": "Event Function Location",
"editable": false,
"description": "The assignments event function location name.",
"type": "string"
},
"event_function.start": {
"label": "Event Function Start Date-Time",
"editable": false,
"description": "The assignments event function start time.",
"type": "string",
"format": "date-time"
},
"event_function.end": {
"label": "Event Function End Date-Time",
"editable": false,
"description": "The assignments event function end time.",
"type": "string",
"format": "date-time"
},
"event_function.is_locked": {
"label": "Event Function is locked",
"editable": false,
"description": "The assignments event function is locked.",
"type": "int",
"format": "bool"
},
"event_function.wage_profile_id": {
"label": "Event Function Wage Profile Id",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"event_function.function": {
"label": "Event Function Name",
"editable": false,
"description": "Name of the event function",
"type": "string"
},
"event_function.function.project_leader": {
"label": "Event Function Team Leader At The Event Level",
"editable": false,
"description": "Flag that decides whether the assignments event function has team leader role at the event level or not.",
"type": "int",
"format": "bool"
},
"event.name": {
"label": "Event Name",
"editable": false,
"description": "The name of the event that the assignment belongs to.",
"type": "string"
},
"event.start": {
"label": "Event Start Date-Time",
"editable": false,
"description": "The start time of the event that the assignment belongs to.",
"type": "string",
"format": "date-time"
},
"event.end": {
"label": "Event End Date-Time",
"editable": false,
"description": "The end time of the event that the assignment belongs to.",
"type": "string",
"format": "date-time"
},
"event.auto_assign_enabled": {
"label": "Event Auto Assign Enabled",
"editable": false,
"description": "The flag that states whether the auto assign is enabled on the event or not.",
"type": "int",
"format": "bool"
},
"event.location.name": {
"label": "Event Location Name",
"editable": false,
"description": "The assignments event location name",
"type": "string"
},
"event.client.name": {
"label": "Event client name",
"editable": false,
"description": "Name of the event client.",
"type": "string"
},
"event.contact.first_name": {
"label": "Client contact first name",
"editable": false,
"description": "First name of the assignment client contact.",
"type": "string"
},
"event.contact.last_name": {
"label": "Client contact last name",
"editable": false,
"description": "Last name of the assignment client contact.",
"type": "string"
},
"event.planner.first_name": {
"label": "Planner first name",
"editable": false,
"description": "First name of the assignment planner.",
"type": "string"
},
"event.planner.last_name": {
"label": "Planner last name",
"editable": false,
"description": "Last name of the assignment planner.",
"type": "string"
},
"event.project.name": {
"label": "Project Name",
"editable": false,
"description": "Name of the assignment project.",
"type": "string"
},
"event.tags": {
"label": "Event tags",
"editable": false,
"description": "Tags of the assignment event.",
"type": "array"
},
"project.event.client.id": {
"label": "Project client ID",
"editable": false,
"description": "ID of the project client.",
"type": "string"
},
"project.event.client.name": {
"label": "Project client name",
"editable": false,
"description": "Name of the project client.",
"type": "string"
},
"project.event.contact.id": {
"label": "Project client contact ID",
"editable": false,
"description": "ID of the project client contact.",
"type": "string"
},
"project.event.contact.first_name": {
"label": "Project client contact first name",
"editable": false,
"description": "First name of the project client contact.",
"type": "string"
},
"project.event.contact.last_name": {
"label": "Project client contact last name",
"editable": false,
"description": "Last name of the project client contact.",
"type": "string"
},
"status": {
"label": "Status",
"editable": true,
"description": "The status of the assignment.",
"type": "integer",
"enum": {
"invited": 1,
"invited_ignored": 2,
"applied": 3,
"applied_maybe": 4,
"denied": 8,
"assigned": 6,
"assigned_provisional": 5,
"confirmed": 7
},
"format": "int",
"valueMapping": {
"1": "Invited",
"2": "Ignored",
"3": "Applied",
"4": "Applied (maybe)",
"5": "Assigned (provisional)",
"6": "Assigned",
"7": "Confirmed",
"8": "Denied"
}
},
"remarks": {
"label": "Remarks",
"editable": true,
"description": "Remarks on the assignment.",
"type": "string"
},
"notes": {
"label": "Notes",
"editable": false,
"description": "Notes on the assignment.",
"type": "string"
},
"start": {
"label": "Start Date-Time",
"editable": false,
"description": "The start time of the assignment.",
"type": "string",
"format": "date-time"
},
"end": {
"label": "End Date-Time",
"editable": false,
"description": "The end time of the assignment",
"type": "string",
"format": "date-time"
},
"break_start": {
"label": "Break Start Date-Time",
"editable": false,
"description": "The start time of the assignment break.",
"type": "string",
"format": "date-time"
},
"break_end": {
"label": "Break End Date-Time",
"editable": false,
"description": "The end time of the assignment break",
"type": "string",
"format": "date-time"
},
"planned_work_time": {
"label": "Planned Work Time including breaks",
"editable": false,
"description": "The assignments planned work time including breaks.",
"type": "string",
"format": "fromHoursIntervalToHumans"
},
"planned_work_time_without_break": {
"label": "Planned Work Time excluding breaks",
"editable": false,
"description": "The assignments planned work time excluding breaks.",
"type": "string",
"format": "fromHoursIntervalToHumans"
},
"planned_break_time": {
"label": "Planned Break Time",
"editable": false,
"description": "The assignments planned break time.",
"type": "string",
"format": "fromHoursIntervalToHumans"
},
"is_approved": {
"label": "Approved",
"editable": false,
"description": "Is assignment data approved by planner",
"type": "int",
"format": "bool"
},
"pay_amount": {
"label": "Approved pay amount",
"editable": false,
"description": "Wage amount that has been approved for payment",
"type": "float",
"format": "currency",
"minimum": 0
},
"approved_on": {
"label": "Payment Approval Date-Time",
"editable": false,
"description": "Date and time when the payment was approved",
"type": "string",
"format": "date-time"
},
"approved_by_planner_id": {
"label": "Id of the planner that approved the payment",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"paid_on": {
"label": "Payment Date-Time",
"editable": false,
"description": "Date and time when the payment was made",
"type": "string",
"format": "date-time"
},
"assigned_by_availability": {
"label": "Assigned by availability",
"editable": false,
"description": "Whether the employee was assigned by its availability or not",
"type": "int",
"format": "bool"
},
"auto_assigned": {
"label": "Auto assigned",
"editable": false,
"description": "Whether the employee was assigned automatically by the system or not",
"type": "int",
"format": "bool"
},
"team_leader_level": {
"label": "Team Leader Level",
"editable": false,
"description": "Team leader level at the event level or project level",
"type": "int",
"format": "int"
},
"created_at": {
"label": "Created Date-Time",
"editable": false,
"description": "The date the assignment was created.",
"type": "string",
"format": "date-time"
},
"updated_at": {
"label": "Updated Date-Time",
"editable": false,
"description": "The date the assignment was updated.",
"type": "string",
"format": "date-time"
},
"open_actions": {
"label": "Open Actions",
"editable": false,
"description": "Contains information about all open actions that can be performed on an assignment",
"type": "object"
},
"configurations": {
"label": "Configurations",
"editable": false,
"description": "Contains information about assignment specific configuration",
"type": "object"
},
"location": {
"label": "Assignment Location",
"editable": false,
"description": "Assignment location address.",
"type": "string"
},
"statistics": {
"label": "Statistics",
"editable": true,
"description": "Contains some filled positions statistics regarding the assigment",
"type": "string"
},
"event_function.start_date": {
"label": "Event Function Start Date-Time Date",
"editable": false,
"description": "The assignments event function start time.",
"type": "string",
"format": "date",
"source": "event_function.start"
},
"event_function.start_time": {
"label": "Event Function Start Date-Time Time",
"editable": false,
"description": "The assignments event function start time.",
"type": "string",
"format": "time",
"source": "event_function.start"
},
"event_function.end_date": {
"label": "Event Function End Date-Time Date",
"editable": false,
"description": "The assignments event function end time.",
"type": "string",
"format": "date",
"source": "event_function.end"
},
"event_function.end_time": {
"label": "Event Function End Date-Time Time",
"editable": false,
"description": "The assignments event function end time.",
"type": "string",
"format": "time",
"source": "event_function.end"
},
"event.start_date": {
"label": "Event Start Date-Time Date",
"editable": false,
"description": "The start time of the event that the assignment belongs to.",
"type": "string",
"format": "date",
"source": "event.start"
},
"event.start_time": {
"label": "Event Start Date-Time Time",
"editable": false,
"description": "The start time of the event that the assignment belongs to.",
"type": "string",
"format": "time",
"source": "event.start"
},
"event.end_date": {
"label": "Event End Date-Time Date",
"editable": false,
"description": "The end time of the event that the assignment belongs to.",
"type": "string",
"format": "date",
"source": "event.end"
},
"event.end_time": {
"label": "Event End Date-Time Time",
"editable": false,
"description": "The end time of the event that the assignment belongs to.",
"type": "string",
"format": "time",
"source": "event.end"
},
"start_date": {
"label": "Start Date-Time Date",
"editable": false,
"description": "The start time of the assignment.",
"type": "string",
"format": "date",
"source": "start"
},
"start_time": {
"label": "Start Date-Time Time",
"editable": false,
"description": "The start time of the assignment.",
"type": "string",
"format": "time",
"source": "start"
},
"end_date": {
"label": "End Date-Time Date",
"editable": false,
"description": "The end time of the assignment",
"type": "string",
"format": "date",
"source": "end"
},
"end_time": {
"label": "End Date-Time Time",
"editable": false,
"description": "The end time of the assignment",
"type": "string",
"format": "time",
"source": "end"
},
"break_start_date": {
"label": "Break Start Date-Time Date",
"editable": false,
"description": "The start time of the assignment break.",
"type": "string",
"format": "date",
"source": "break_start"
},
"break_start_time": {
"label": "Break Start Date-Time Time",
"editable": false,
"description": "The start time of the assignment break.",
"type": "string",
"format": "time",
"source": "break_start"
},
"break_end_date": {
"label": "Break End Date-Time Date",
"editable": false,
"description": "The end time of the assignment break",
"type": "string",
"format": "date",
"source": "break_end"
},
"break_end_time": {
"label": "Break End Date-Time Time",
"editable": false,
"description": "The end time of the assignment break",
"type": "string",
"format": "time",
"source": "break_end"
},
"approved_on_date": {
"label": "Payment Approval Date-Time Date",
"editable": false,
"description": "Date and time when the payment was approved",
"type": "string",
"format": "date",
"source": "approved_on"
},
"approved_on_time": {
"label": "Payment Approval Date-Time Time",
"editable": false,
"description": "Date and time when the payment was approved",
"type": "string",
"format": "time",
"source": "approved_on"
},
"paid_on_date": {
"label": "Payment Date-Time Date",
"editable": false,
"description": "Date and time when the payment was made",
"type": "string",
"format": "date",
"source": "paid_on"
},
"paid_on_time": {
"label": "Payment Date-Time Time",
"editable": false,
"description": "Date and time when the payment was made",
"type": "string",
"format": "time",
"source": "paid_on"
},
"created_at_date": {
"label": "Created Date-Time Date",
"editable": false,
"description": "The date the assignment was created.",
"type": "string",
"format": "date",
"source": "created_at"
},
"created_at_time": {
"label": "Created Date-Time Time",
"editable": false,
"description": "The date the assignment was created.",
"type": "string",
"format": "time",
"source": "created_at"
},
"updated_at_date": {
"label": "Updated Date-Time Date",
"editable": false,
"description": "The date the assignment was updated.",
"type": "string",
"format": "date",
"source": "updated_at"
},
"updated_at_time": {
"label": "Updated Date-Time Time",
"editable": false,
"description": "The date the assignment was updated.",
"type": "string",
"format": "time",
"source": "updated_at"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| employee_id | Read Only | foreignKey (int) | Employee Id |
| event_function_id | Read Only | foreignKey (int) | Event Function Id |
| event_id | Read Only | foreignKey (int) | Event Id |
| project_id | Read Only | foreignKey (int) | Project Id |
| client_id | Read Only | foreignKey (int) | Client Id |
| contact_id | Read Only | foreignKey (int) | Contact Id |
| planner_id | Read Only | foreignKey (int) | Planner Id |
| location_id | Read Only | foreignKey (int) | Location Id |
| wage_profile_id | Read Only | foreignKey (int) | Assignment Wage Profile Id |
| event_function.id | Read Only | int | Event Function ID ID of the event function |
| event_function.function_id | Read Only | int | Function ID ID of the event function |
| event_function.description | Read Only | string | Event Function Description Short description of the event function referenced by the assignment. |
| event_function.location.name | Read Only | string | Event Function Location The assignments event function location name. |
| event_function.start | Read Only | string (date-time) | Event Function Start Date-Time The assignments event function start time. |
| event_function.end | Read Only | string (date-time) | Event Function End Date-Time The assignments event function end time. |
| event_function.is_locked | Read Only | int (bool) | Event Function is locked The assignments event function is locked. |
| event_function.wage_profile_id | Read Only | foreignKey (int) | Event Function Wage Profile Id |
| event_function.function | Read Only | string | Event Function Name Name of the event function |
| event_function.function.project_leader | Read Only | int (bool) | Event Function Team Leader At The Event Level Flag that decides whether the assignments event function has team leader role at the event level or not. |
| event.name | Read Only | string | Event Name The name of the event that the assignment belongs to. |
| event.start | Read Only | string (date-time) | Event Start Date-Time The start time of the event that the assignment belongs to. |
| event.end | Read Only | string (date-time) | Event End Date-Time The end time of the event that the assignment belongs to. |
| event.auto_assign_enabled | Read Only | int (bool) | Event Auto Assign Enabled The flag that states whether the auto assign is enabled on the event or not. |
| event.location.name | Read Only | string | Event Location Name The assignments event location name |
| event.client.name | Read Only | string | Event client name Name of the event client. |
| event.contact.first_name | Read Only | string | Client contact first name First name of the assignment client contact. |
| event.contact.last_name | Read Only | string | Client contact last name Last name of the assignment client contact. |
| event.planner.first_name | Read Only | string | Planner first name First name of the assignment planner. |
| event.planner.last_name | Read Only | string | Planner last name Last name of the assignment planner. |
| event.project.name | Read Only | string | Project Name Name of the assignment project. |
| event.tags | Read Only | array | Event tags Tags of the assignment event. |
| project.event.client.id | Read Only | string | Project client ID ID of the project client. |
| project.event.client.name | Read Only | string | Project client name Name of the project client. |
| project.event.contact.id | Read Only | string | Project client contact ID ID of the project client contact. |
| project.event.contact.first_name | Read Only | string | Project client contact first name First name of the project client contact. |
| project.event.contact.last_name | Read Only | string | Project client contact last name Last name of the project client contact. |
| status | integer (int) | Status The status of the assignment. | |
| remarks | string | Remarks Remarks on the assignment. | |
| notes | Read Only | string | Notes Notes on the assignment. |
| start | Read Only | string (date-time) | Start Date-Time The start time of the assignment. |
| end | Read Only | string (date-time) | End Date-Time The end time of the assignment |
| break_start | Read Only | string (date-time) | Break Start Date-Time The start time of the assignment break. |
| break_end | Read Only | string (date-time) | Break End Date-Time The end time of the assignment break |
| planned_work_time | Read Only | string (fromHoursIntervalToHumans) | Planned Work Time including breaks The assignments planned work time including breaks. |
| planned_work_time_without_break | Read Only | string (fromHoursIntervalToHumans) | Planned Work Time excluding breaks The assignments planned work time excluding breaks. |
| planned_break_time | Read Only | string (fromHoursIntervalToHumans) | Planned Break Time The assignments planned break time. |
| is_approved | Read Only | int (bool) | Approved Is assignment data approved by planner |
| pay_amount | Read Only | float (currency) | Approved pay amount Wage amount that has been approved for payment |
| approved_on | Read Only | string (date-time) | Payment Approval Date-Time Date and time when the payment was approved |
| approved_by_planner_id | Read Only | foreignKey (int) | Id of the planner that approved the payment |
| paid_on | Read Only | string (date-time) | Payment Date-Time Date and time when the payment was made |
| assigned_by_availability | Read Only | int (bool) | Assigned by availability Whether the employee was assigned by its availability or not |
| auto_assigned | Read Only | int (bool) | Auto assigned Whether the employee was assigned automatically by the system or not |
| team_leader_level | Read Only | int (int) | Team Leader Level Team leader level at the event level or project level |
| created_at | Read Only | string (date-time) | Created Date-Time The date the assignment was created. |
| updated_at | Read Only | string (date-time) | Updated Date-Time The date the assignment was updated. |
| open_actions | Read Only | object | Open Actions Contains information about all open actions that can be performed on an assignment |
| configurations | Read Only | object | Configurations Contains information about assignment specific configuration |
| location | Read Only | string | Assignment Location Assignment location address. |
| statistics | string | Statistics Contains some filled positions statistics regarding the assigment | |
| event_function.start_date | Read Only | string (date) | Event Function Start Date-Time Date The assignments event function start time. |
| event_function.start_time | Read Only | string (time) | Event Function Start Date-Time Time The assignments event function start time. |
| event_function.end_date | Read Only | string (date) | Event Function End Date-Time Date The assignments event function end time. |
| event_function.end_time | Read Only | string (time) | Event Function End Date-Time Time The assignments event function end time. |
| event.start_date | Read Only | string (date) | Event Start Date-Time Date The start time of the event that the assignment belongs to. |
| event.start_time | Read Only | string (time) | Event Start Date-Time Time The start time of the event that the assignment belongs to. |
| event.end_date | Read Only | string (date) | Event End Date-Time Date The end time of the event that the assignment belongs to. |
| event.end_time | Read Only | string (time) | Event End Date-Time Time The end time of the event that the assignment belongs to. |
| start_date | Read Only | string (date) | Start Date-Time Date The start time of the assignment. |
| start_time | Read Only | string (time) | Start Date-Time Time The start time of the assignment. |
| end_date | Read Only | string (date) | End Date-Time Date The end time of the assignment |
| end_time | Read Only | string (time) | End Date-Time Time The end time of the assignment |
| break_start_date | Read Only | string (date) | Break Start Date-Time Date The start time of the assignment break. |
| break_start_time | Read Only | string (time) | Break Start Date-Time Time The start time of the assignment break. |
| break_end_date | Read Only | string (date) | Break End Date-Time Date The end time of the assignment break |
| break_end_time | Read Only | string (time) | Break End Date-Time Time The end time of the assignment break |
| approved_on_date | Read Only | string (date) | Payment Approval Date-Time Date Date and time when the payment was approved |
| approved_on_time | Read Only | string (time) | Payment Approval Date-Time Time Date and time when the payment was approved |
| paid_on_date | Read Only | string (date) | Payment Date-Time Date Date and time when the payment was made |
| paid_on_time | Read Only | string (time) | Payment Date-Time Time Date and time when the payment was made |
| created_at_date | Read Only | string (date) | Created Date-Time Date The date the assignment was created. |
| created_at_time | Read Only | string (time) | Created Date-Time Time The date the assignment was created. |
| updated_at_date | Read Only | string (date) | Updated Date-Time Date The date the assignment was updated. |
| updated_at_time | Read Only | string (time) | Updated Date-Time Time The date the assignment was updated. |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| assignmentEmployee | employees | assignments.employee_id | Employee referenced by the assignment. |
| assignmentEvent | events | assignments.event_id | Event referenced by the assignment. |
| assignmentProject | projects | assignments.project_id | Project referenced by the assignment. |
| assignmentFunction | event-functions | assignments.event_function_id | Function referenced by the assignment. |
| assignmentWageProfile | wage-profiles | assignments.wage_profile_id | Wage profile referenced by the assignment. |
| assignmentLocation | locations | assignments.location_id | Location of the assignment. |
| paysheets | paysheets | paysheets.assignment_id | |
| work-times | work-times | work-times.event_function_employee_id | |
| wages | assignment-wages | assignment-wages.assignment_id | |
| report | assignment-employment-reports | assignment-employment-reports.assignment_id | |
| contract | assignment-contract | assignment-contract.assignment_id | |
| work-time-proposals | work-time-proposals | work-time-proposals.assignment_id | |
| wage-proposals | wage-proposals | wage-proposals.assignment_id | |
| livestamps | livestamps | livestamps.assignment_id | |
| checkins | checkins | checkins.assignment_id | |
| pre-checkins | pre-checkins | pre-checkins.assignment_id |
Actions
| Request | Description |
|---|---|
GET /assignments | Resource listing |
GET /assignments/<id> | Resource read |
POST /assignments | Resource create |
PUT /assignments/<id> | Resource update |
DELETE /assignments/<id> | Resource delete |
GET /assignments/<id>/status-map | Available assignment status values. |
PUT /assignments/<id>/status | Change assignment specific state |
PUT /assignments/<id>/status | Bulk change assignments states |
GET /assignments/<id>/teamsheet | Get the team sheet for a specific assignment |
GET /assignments/<id>/open-actions | Get open actions for a specific assignment. |
GET /assignments/<id>/configurations | Get configurations for a specific assignment |
GET /assignments/<id>/configurations | Get configurations for a set of given assignment |
PUT /assignments/<id>/pay | Set payment time for a specific assignment |
GET /assignments/<id>/reporting-forms | Get reporting forms attached to a particular assignment via related event / project. |
GET /assignments/<id>/reporting-forms | Get reporting forms attached to multiple assignments via related events / projects. |
POST /assignments/<id>/signed-work-data | Post signed work data like work times proposals. |
GET /assignments/<id>/signed-work-data | Get configurations for signed work data Note: this action is deprecated. Use GET /assignments/ |
GET /assignments/<id>/signed-work-data-approvers | Get the approvers that can sign work data |
PUT /assignments/<id>/time | Set time for a specific assignment |
Attributes
Schema
Attributes schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"collection_id": {
"label": "Project ID",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"entity_id": {
"label": "Entity ID",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"type_id": {
"label": "Attribute type ID",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"identifier": {
"label": "Identifier",
"type": "string",
"editable": false,
"format": "string"
},
"name": {
"label": "Label",
"type": "string",
"editable": false,
"format": "string"
},
"language_id": {
"label": "Language ID",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"is_locked_employees": {
"label": "Is locked for employees",
"type": "integer",
"format": "bool",
"editable": false
},
"read_only_for_recruiting_forms": {
"label": "Enable read-only for recruiting forms",
"type": "integer",
"format": "bool",
"editable": false
},
"deletable": {
"label": "Is deletable",
"type": "int",
"format": "bool",
"editable": false
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| collection_id | Read Only | foreignKey (int) | Project ID |
| entity_id | Read Only | foreignKey (int) | Entity ID |
| type_id | Read Only | foreignKey (int) | Attribute type ID |
| identifier | Read Only | string (string) | Identifier |
| name | Read Only | string (string) | Label |
| language_id | Read Only | foreignKey (int) | Language ID |
| is_locked_employees | Read Only | integer (bool) | Is locked for employees |
| read_only_for_recruiting_forms | Read Only | integer (bool) | Enable read-only for recruiting forms |
| deletable | Read Only | int (bool) | Is deletable |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| attributeCollection | collections | attributes.collection_id | |
| languages | languages | attributes.language_id |
Actions
| Request | Description |
|---|---|
GET /attributes | Resource listing |
GET /attributes/<id> | Resource read |
POST /attributes | Resource create |
PUT /attributes/<id> | Resource update |
DELETE /attributes/<id> | Resource delete |
Automations
Schema
Automations schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"trigger_type": {
"label": "Trigger Type",
"editable": true,
"type": "string",
"format": "string"
},
"trigger_configuration": {
"label": "Trigger Configuration",
"editable": true,
"type": "string",
"format": "json"
},
"routine_type": {
"label": "Routine Type",
"editable": true,
"type": "string",
"format": "string"
},
"routine_configuration": {
"label": "Routine Configuration",
"editable": true,
"type": "string",
"format": "json"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| trigger_type | string (string) | Trigger Type | |
| trigger_configuration | string (json) | Trigger Configuration | |
| routine_type | string (string) | Routine Type | |
| routine_configuration | string (json) | Routine Configuration |
Actions
| Request | Description |
|---|---|
GET /automations | Resource listing |
GET /automations/<id> | Resource read |
POST /automations | Resource create |
PUT /automations/<id> | Resource update |
DELETE /automations/<id> | Resource delete |
Availability requests
Schema
Availability-requests schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"employee_id": {
"label": "Employee ID",
"editable": false,
"type": "foreignKey",
"format": "int"
},
"name": {
"label": "Name",
"editable": false,
"type": "string",
"format": "string"
},
"from": {
"label": "From date",
"editable": false,
"type": "string",
"format": "string"
},
"to": {
"label": "To date",
"editable": false,
"type": "string",
"format": "string"
},
"blocked_at": {
"label": "Request blocked at date",
"editable": false,
"type": "string",
"format": "string"
},
"completed_at": {
"label": "Request completed at date",
"editable": false,
"type": "string",
"format": "string"
},
"completed_by_enforcement": {
"label": "Request completed by enforcement",
"editable": false,
"type": "integer",
"format": "bool"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| employee_id | Read Only | foreignKey (int) | Employee ID |
| name | Read Only | string (string) | Name |
| from | Read Only | string (string) | From date |
| to | Read Only | string (string) | To date |
| blocked_at | Read Only | string (string) | Request blocked at date |
| completed_at | Read Only | string (string) | Request completed at date |
| completed_by_enforcement | Read Only | integer (bool) | Request completed by enforcement |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| employee | employees | availability-requests.employee_id | |
| definition | availability-requests-definitions | availability-requests.id | |
| availabilities | availability-requests-availabilities | availability-requests.id |
Actions
| Request | Description |
|---|---|
GET /availability-requests | Resource listing |
GET /availability-requests/<id> | Resource read |
POST /availability-requests | Resource create |
PUT /availability-requests/<id> | Resource update |
DELETE /availability-requests/<id> | Resource delete |
Availability requests availabilities
Schema
Availability-requests-availabilities schema
{
"properties": {
"availability_request_id": {
"label": "Availability request ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"employee_id": {
"label": "Employee ID",
"editable": false,
"type": "int",
"format": "int"
},
"availabilities": {
"label": "Availabilities",
"editable": false,
"type": "array",
"format": "array"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| availability_request_id | Read Only | identityField (int) | Availability request ID |
| employee_id | Read Only | int (int) | Employee ID |
| availabilities | Read Only | array (array) | Availabilities |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| availability-request | availability-requests | availability-requests-availabilities.availability_request_id | |
| employee | employees | availability-requests-availabilities.employee_id |
Actions
| Request | Description |
|---|---|
GET /availability-requests-availabilities | Resource listing |
GET /availability-requests-availabilities/<id> | Resource read |
POST /availability-requests-availabilities | Resource create |
PUT /availability-requests-availabilities/<id> | Resource update |
DELETE /availability-requests-availabilities/<id> | Resource delete |
Availability requests definitions
Schema
Availability-requests-definitions schema
{
"properties": {
"availability_request_id": {
"label": "Availability request ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"rules": {
"label": "Rules",
"editable": false,
"type": "array",
"format": "array"
},
"time_slots": {
"label": "Time slots",
"editable": false,
"type": "array",
"format": "array"
},
"requested_availabilities": {
"label": "Requested availabilities",
"editable": false,
"type": "array",
"format": "array"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| availability_request_id | Read Only | identityField (int) | Availability request ID |
| rules | Read Only | array (array) | Rules |
| time_slots | Read Only | array (array) | Time slots |
| requested_availabilities | Read Only | array (array) | Requested availabilities |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| availability-request | availability-requests | availability-requests-definitions.availability_request_id |
Actions
| Request | Description |
|---|---|
GET /availability-requests-definitions | Resource listing |
GET /availability-requests-definitions/<id> | Resource read |
POST /availability-requests-definitions | Resource create |
PUT /availability-requests-definitions/<id> | Resource update |
DELETE /availability-requests-definitions/<id> | Resource delete |
Busy dates
Schema
Busy-dates schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"employee_id": {
"label": "Employee Id",
"editable": true,
"type": "foreignKey",
"format": "int"
},
"description": {
"label": "Description",
"editable": true,
"type": "string",
"format": "string"
},
"type": {
"label": "Type",
"editable": true,
"type": "string",
"format": "string",
"enum": [
"vacation",
"paid_training",
"sick_leave",
"parental_leave",
"compensation_time",
"day_off",
"no_show",
"other"
],
"valueMapping": {
"vacation": "Vacation",
"paid_training": "Paid training",
"sick_leave": "Sick leave",
"parental_leave": "Parental leave",
"compensation_time": "Compensation time",
"day_off": "Day Off",
"no_show": "No Show",
"other": "Other"
}
},
"reason": {
"label": "Reason (deprecated)",
"editable": true,
"type": "string",
"format": "string",
"description": "This field is deprecated and will be removed in the future. Instead of this field use the type and description fields."
},
"start": {
"label": "Start Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"end": {
"label": "End Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"busy_entry": {
"label": "Busy date configuration",
"type": "object"
},
"files_ids": {
"label": "Busy dates files IDs (optional)",
"editable": true,
"description": "The IDs of the files to be added to the busy dates.",
"type": "array",
"format": "array"
},
"start_date": {
"label": "Start Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "start"
},
"start_time": {
"label": "Start Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "start"
},
"end_date": {
"label": "End Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "end"
},
"end_time": {
"label": "End Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "end"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| employee_id | foreignKey (int) | Employee Id | |
| description | string (string) | Description | |
| type | string (string) | Type | |
| reason | string (string) | Reason (deprecated) This field is deprecated and will be removed in the future. Instead of this field use the type and description fields. | |
| start | Read Only | string (date-time) | Start Date-Time |
| end | Read Only | string (date-time) | End Date-Time |
| busy_entry | Read Only | object | Busy date configuration |
| files_ids | array (array) | Busy dates files IDs (optional) The IDs of the files to be added to the busy dates. | |
| start_date | Read Only | string (date) | Start Date-Time Date |
| start_time | Read Only | string (time) | Start Date-Time Time |
| end_date | Read Only | string (date) | End Date-Time Date |
| end_time | Read Only | string (time) | End Date-Time Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| busyDatesEmployee | employees | busy-dates.employee_id |
Actions
| Request | Description |
|---|---|
GET /busy-dates | Resource listing |
GET /busy-dates/<id> | Resource read |
POST /busy-dates | Resource create |
PUT /busy-dates/<id> | Resource update |
DELETE /busy-dates/<id> | Resource delete |
Checkins
Schema
Checkins schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField"
},
"assignment_id": {
"label": "Assignment ID",
"type": "foreignKey",
"editable": false
},
"timestamp": {
"label": "Timestamp Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"hash": {
"label": "Hash",
"description": "Optional check-in hash.",
"editable": false,
"type": "string"
},
"metadata": {
"label": "Metadata",
"description": "Check-in metadata.",
"editable": false,
"type": "associativeArray"
},
"source": {
"label": "Source",
"editable": false,
"type": "int",
"enum": [
1,
2,
3
],
"valueMapping": {
"1": "QR code",
"2": "External",
"3": "NFC"
}
},
"type": {
"label": "Type",
"editable": false,
"type": "int",
"enum": [
1,
2,
3,
4
],
"valueMapping": {
"1": "Start",
"2": "Break Start",
"3": "Break End",
"4": "End"
}
},
"created_at": {
"label": "Created",
"editable": false
},
"timestamp_date": {
"label": "Timestamp Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "timestamp"
},
"timestamp_time": {
"label": "Timestamp Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "timestamp"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField | ID |
| assignment_id | Read Only | foreignKey | Assignment ID |
| timestamp | Read Only | string (date-time) | Timestamp Date-Time |
| hash | Read Only | string | Hash Optional check-in hash. |
| metadata | Read Only | associativeArray | Metadata Check-in metadata. |
| source | Read Only | int | Source |
| type | Read Only | int | Type |
| created_at | Read Only | Created | |
| timestamp_date | Read Only | string (date) | Timestamp Date-Time Date |
| timestamp_time | Read Only | string (time) | Timestamp Date-Time Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| checkInAssignment | assignments | checkins.assignment_id |
Actions
| Request | Description |
|---|---|
GET /checkins | Resource listing |
GET /checkins/<id> | Resource read |
POST /checkins | Resource create |
PUT /checkins/<id> | Resource update |
DELETE /checkins/<id> | Resource delete |
Clients
This resource uses dynamic fields.
Schema
Clients schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"relation_id": {
"label": "Relation ID",
"type": "foreignKey",
"editable": false,
"format": "int"
},
"status": {
"label": "Status",
"editable": true,
"type": "integer",
"enum": [
1,
2
],
"format": "int",
"valueMapping": {
"1": "Active",
"2": "Inactive"
}
},
"created_at": {
"label": "Created Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"updated_at": {
"label": "Updated Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"company": {
"label": "Company name",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 11,
"input_type": "text"
},
"address_first": {
"label": "Address line 1",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 12,
"input_type": "text"
},
"address_second": {
"label": "Address line 2",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 13,
"input_type": "text"
},
"zip": {
"label": "ZIP",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 14,
"input_type": "text"
},
"city": {
"label": "City",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 15,
"input_type": "text"
},
"country": {
"label": "Country",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 16,
"input_type": "select"
},
"dynamic_field_86": {
"label": "Checkbox",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 86,
"input_type": "boolean"
},
"dynamic_field_212": {
"label": "[missing translation]",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 212,
"input_type": "select"
},
"created_at_date": {
"label": "Created Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "created_at"
},
"created_at_time": {
"label": "Created Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "created_at"
},
"updated_at_date": {
"label": "Updated Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "updated_at"
},
"updated_at_time": {
"label": "Updated Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "updated_at"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| relation_id | Read Only | foreignKey (int) | Relation ID |
| status | integer (int) | Status | |
| created_at | Read Only | string (date-time) | Created Date-Time |
| updated_at | Read Only | string (date-time) | Updated Date-Time |
| company | Dynamic Field | Company name | |
| address_first | Dynamic Field | Address line 1 | |
| address_second | Dynamic Field | Address line 2 | |
| zip | Dynamic Field | ZIP | |
| city | Dynamic Field | City | |
| country | Dynamic Field | Country | |
| dynamic_field_86 | Dynamic Field | Checkbox | |
| dynamic_field_212 | Dynamic Field | [missing translation] | |
| created_at_date | Read Only | string (date) | Created Date-Time Date |
| created_at_time | Read Only | string (time) | Created Date-Time Time |
| updated_at_date | Read Only | string (date) | Updated Date-Time Date |
| updated_at_time | Read Only | string (time) | Updated Date-Time Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| clientEvents | events | events.client_id | |
| clientProjects | projects | projects.client_id | |
| clientContacts | contacts | contacts.client_id |
Actions
| Request | Description |
|---|---|
GET /clients | Resource listing |
GET /clients/<id> | Resource read |
POST /clients | Resource create |
PUT /clients/<id> | Resource update |
DELETE /clients/<id> | Resource delete Note: this action is deprecated. In order to mark a client as deleted you can use PUT /clients/<id> action by sending { status: 2 } as one of the parameters |
Collections
Schema
Collections schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"identifier": {
"label": "Identifier",
"editable": false,
"type": "string",
"format": "string"
},
"name": {
"label": "Name",
"editable": true,
"type": "string",
"format": "string"
},
"editable": {
"label": "Editable",
"editable": false,
"type": "integer",
"format": "bool"
},
"visible": {
"label": "Visible",
"editable": false,
"type": "integer",
"format": "bool"
},
"deleted": {
"label": "Deleted",
"editable": true,
"type": "integer",
"format": "bool"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| identifier | Read Only | string (string) | Identifier |
| name | string (string) | Name | |
| editable | Read Only | integer (bool) | Editable |
| visible | Read Only | integer (bool) | Visible |
| deleted | integer (bool) | Deleted |
Actions
| Request | Description |
|---|---|
GET /collections | Resource listing Note: This returns all collections, including those marked as deleted. Use GET /collections?deleted=0 to filter out collections marked as deleted. |
GET /collections/<id> | Resource read |
POST /collections | Resource create |
PUT /collections/<id> | Resource update |
DELETE /collections/<id> | Resource delete Note: this action is deprecated. In order to mark a collection as deleted you can use PUT /collections/<id> action by sending { deleted: true } as one of the parameters |
GET /collections/<id>/values | List all values of a specific collection |
GET /collections/<id>/objects | List all objects of a specific collection |
POST /collections/<id>/value | Add new value to a collection |
GET /collections/<id>/value | Get specific value from a collection |
PUT /collections/<id>/value | Update specific value from a collection |
DELETE /collections/<id>/value | Delete specific value from a collection Note: this action is deprecated. In order to mark a collection item as deleted you can use PUT /collections/<id>/value action by sending { deleted: true } as one of the parameters |
Contacts
This resource uses dynamic fields.
Schema
Contacts schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"relation_id": {
"label": "Relation ID",
"type": "foreignKey",
"editable": false,
"format": "int"
},
"client_id": {
"label": "Client ID",
"type": "foreignKey",
"editable": true,
"format": "int"
},
"status": {
"label": "Status",
"editable": true,
"type": "integer",
"enum": [
1,
2
],
"format": "int",
"valueMapping": {
"1": "Active",
"2": "Inactive"
}
},
"created_at": {
"label": "Created Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"updated_at": {
"label": "Updated Date-Time",
"editable": false,
"type": "string",
"format": "date-time"
},
"firstname": {
"label": "First name",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 17,
"input_type": "text"
},
"lastname": {
"label": "Last name",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 18,
"input_type": "text"
},
"email": {
"label": "Email address",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 19,
"input_type": "email"
},
"mobile": {
"label": "Mobile number",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 20,
"input_type": "phone"
},
"gender": {
"label": "Gender",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 53,
"input_type": "select"
},
"dynamic_field_167": {
"label": "[missing translation]",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 167,
"input_type": "text"
},
"created_at_date": {
"label": "Created Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "created_at"
},
"created_at_time": {
"label": "Created Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "created_at"
},
"updated_at_date": {
"label": "Updated Date-Time Date",
"editable": false,
"type": "string",
"format": "date",
"source": "updated_at"
},
"updated_at_time": {
"label": "Updated Date-Time Time",
"editable": false,
"type": "string",
"format": "time",
"source": "updated_at"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| relation_id | Read Only | foreignKey (int) | Relation ID |
| client_id | foreignKey (int) | Client ID | |
| status | integer (int) | Status | |
| created_at | Read Only | string (date-time) | Created Date-Time |
| updated_at | Read Only | string (date-time) | Updated Date-Time |
| firstname | Dynamic Field | First name | |
| lastname | Dynamic Field | Last name | |
Dynamic Field | Email address | ||
| mobile | Dynamic Field | Mobile number | |
| gender | Dynamic Field | Gender | |
| dynamic_field_167 | Dynamic Field | [missing translation] | |
| created_at_date | Read Only | string (date) | Created Date-Time Date |
| created_at_time | Read Only | string (time) | Created Date-Time Time |
| updated_at_date | Read Only | string (date) | Updated Date-Time Date |
| updated_at_time | Read Only | string (time) | Updated Date-Time Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| contactClient | clients | contacts.client_id | |
| contactEvents | events | events.contact_id | |
| contactProjects | projects | projects.contact_id |
Actions
| Request | Description |
|---|---|
GET /contacts | Resource listing |
GET /contacts/<id> | Resource read |
POST /contacts | Resource create |
PUT /contacts/<id> | Resource update |
DELETE /contacts/<id> | Resource delete Note: this action is deprecated. In order to mark a contact as deleted you can use PUT /contacts/<id> action by sending { status: 2 } as one of the parameters |
Counties
Schema
Counties schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"name": {
"label": "Name",
"editable": false,
"type": "string",
"format": "string"
},
"code": {
"label": "Code",
"editable": false,
"type": "string",
"format": "string"
},
"country": {
"label": "Country",
"editable": false,
"type": "string",
"format": "string"
},
"deleted": {
"label": "Deleted",
"editable": false,
"type": "integer",
"format": "bool",
"description": "Whether the county is deleted or not."
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| name | Read Only | string (string) | Name |
| code | Read Only | string (string) | Code |
| country | Read Only | string (string) | Country |
| deleted | Read Only | integer (bool) | Deleted Whether the county is deleted or not. |
Actions
| Request | Description |
|---|---|
GET /counties | Resource listing |
GET /counties/<id> | Resource read |
POST /counties | Resource create |
PUT /counties/<id> | Resource update |
DELETE /counties/<id> | Resource delete |
Employee availability
Schema
Employee-availability schema
{
"properties": {
"time_slot_id": {
"label": "Time slot ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"date": {
"label": "Availability date",
"editable": false,
"type": "string",
"format": "date"
},
"employee_id": {
"label": "Employee ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"availability_request_name": {
"label": "Availability request name",
"editable": false,
"type": "string",
"format": "string"
},
"planner_name": {
"label": "Availability planner name",
"editable": false,
"type": "string",
"format": "string"
},
"completed_at": {
"label": "Request completed at",
"editable": false,
"type": "string",
"format": "date-time"
},
"completed_at_date": {
"label": "Request completed at Date",
"editable": false,
"type": "string",
"format": "date",
"source": "completed_at"
},
"completed_at_time": {
"label": "Request completed at Time",
"editable": false,
"type": "string",
"format": "time",
"source": "completed_at"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| time_slot_id | Read Only | identityField (int) | Time slot ID |
| date | Read Only | string (date) | Availability date |
| employee_id | Read Only | identityField (int) | Employee ID |
| availability_request_name | Read Only | string (string) | Availability request name |
| planner_name | Read Only | string (string) | Availability planner name |
| completed_at | Read Only | string (date-time) | Request completed at |
| completed_at_date | Read Only | string (date) | Request completed at Date |
| completed_at_time | Read Only | string (time) | Request completed at Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| employee | employees | employee-availability.employee_id | |
| timeSlot | time-slots | employee-availability.time_slot_id |
Actions
| Request | Description |
|---|---|
GET /employee-availability | Resource listing |
GET /employee-availability/<id> | Resource read |
POST /employee-availability | Resource create |
PUT /employee-availability/<id> | Resource update |
DELETE /employee-availability/<id> | Resource delete |
Employee notes
Schema
Employee-notes schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"employee_id": {
"label": "Employee ID",
"type": "foreignKey",
"editable": true,
"format": "int",
"description": "The ID of the employee this note belongs to."
},
"planner_id": {
"label": "Planner ID",
"type": "foreignKey",
"editable": false,
"format": "int",
"description": "The ID of the planner who created or last modified the note. Automatically set to the authenticated planner."
},
"content": {
"label": "Content",
"type": "string",
"editable": true,
"description": "The content of the note. HTML tags will be sanitized."
},
"created_at": {
"label": "Created on",
"editable": false,
"type": "string",
"format": "date-time"
},
"updated_at": {
"label": "Updated on",
"editable": false,
"type": "string",
"format": "date-time"
},
"created_at_date": {
"label": "Created on Date",
"editable": false,
"type": "string",
"format": "date",
"source": "created_at"
},
"created_at_time": {
"label": "Created on Time",
"editable": false,
"type": "string",
"format": "time",
"source": "created_at"
},
"updated_at_date": {
"label": "Last update Date",
"editable": false,
"type": "string",
"format": "date",
"source": "updated_at"
},
"updated_at_time": {
"label": "Last update Time",
"editable": false,
"type": "string",
"format": "time",
"source": "updated_at"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| employee_id | foreignKey (int) | Employee ID The ID of the employee this note belongs to. | |
| planner_id | Read Only | foreignKey (int) | Planner ID The ID of the planner who created or last modified the note. Automatically set to the authenticated planner. |
| content | string | Content The content of the note. HTML tags will be sanitized. | |
| created_at | Read Only | string (date-time) | Created on |
| updated_at | Read Only | string (date-time) | Updated on |
| created_at_date | Read Only | string (date) | Created on Date |
| created_at_time | Read Only | string (time) | Created on Time |
| updated_at_date | Read Only | string (date) | Last update Date |
| updated_at_time | Read Only | string (time) | Last update Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| employee | employees | employee-notes.employee_id |
Actions
| Request | Description |
|---|---|
GET /employee-notes | Resource listing |
GET /employee-notes/<id> | Resource read |
POST /employee-notes | Resource create |
PUT /employee-notes/<id> | Resource update |
DELETE /employee-notes/<id> | Resource delete |
Employee pictures
Schema
Employee-pictures schema
{
"properties": {
"id": {
"label": "ID",
"editable": false,
"type": "identityField",
"format": "int"
},
"employee_id": {
"label": "Employee Id",
"type": "foreignKey",
"editable": false,
"format": "int"
},
"file_id": {
"label": "File Id",
"type": "foreignKey",
"editable": false,
"format": "int"
},
"order": {
"label": "Order index",
"editable": true,
"type": "integer",
"format": "int"
},
"is_profile_picture": {
"label": "Is Profile Picture",
"editable": true,
"type": "integer",
"format": "bool"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| id | Read Only | identityField (int) | ID |
| employee_id | Read Only | foreignKey (int) | Employee Id |
| file_id | Read Only | foreignKey (int) | File Id |
| order | integer (int) | Order index | |
| is_profile_picture | integer (bool) | Is Profile Picture |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| employee | employees | employee-pictures.employee_id | |
| file | files | employee-pictures.file_id |
Actions
| Request | Description |
|---|---|
GET /employee-pictures | Resource listing |
GET /employee-pictures/<id> | Resource read |
POST /employee-pictures | Resource create |
PUT /employee-pictures/<id> | Resource update |
DELETE /employee-pictures/<id> | Resource delete |
Employee teams
Schema
Employee-teams schema
{
"properties": {
"employee_id": {
"label": "Employee ID",
"type": "foreignKey",
"editable": false,
"format": "int"
},
"team_id": {
"label": "Team ID",
"type": "int",
"editable": false,
"format": "int"
},
"team_name": {
"label": "Team name",
"type": "string",
"editable": false,
"format": "string"
},
"team_created_at": {
"label": "Team Created At Date-Time",
"type": "string",
"editable": false,
"format": "date-time"
},
"team_created_at_date": {
"label": "Team Created At Date-Time Date",
"type": "string",
"editable": false,
"format": "date",
"source": "team_created_at"
},
"team_created_at_time": {
"label": "Team Created At Date-Time Time",
"type": "string",
"editable": false,
"format": "time",
"source": "team_created_at"
}
}
}Fields
| Name | Properties | Type | Description |
|---|---|---|---|
| employee_id | Read Only | foreignKey (int) | Employee ID |
| team_id | Read Only | int (int) | Team ID |
| team_name | Read Only | string (string) | Team name |
| team_created_at | Read Only | string (date-time) | Team Created At Date-Time |
| team_created_at_date | Read Only | string (date) | Team Created At Date-Time Date |
| team_created_at_time | Read Only | string (time) | Team Created At Date-Time Time |
Relations
| Name | Resource | Foreign Key | Description |
|---|---|---|---|
| employee | employees | employee-teams.employee_id |
Actions
| Request | Description |
|---|---|
GET /employee-teams | Resource listing |
GET /employee-teams/<id> | Resource read |
POST /employee-teams | Resource create |
PUT /employee-teams/<id> | Resource update |
DELETE /employee-teams/<id> | Resource delete |
Employees
This resource uses dynamic fields.
Schema
Employees schema
{
"properties": {
"id": {
"label": "ID",
"type": "identityField",
"format": "int",
"editable": false
},
"status": {
"label": "Status",
"type": "integer",
"editable": true,
"enum": [
0,
1,
2,
3,
4,
5,
6
],
"valueMapping": [
"Uncompleted",
"Applicant",
"Provisional candidate",
"Candidate",
"Active",
"Inactive",
"Deleted"
],
"format": "int"
},
"wage_profile_id": {
"label": "Wage Profile ID",
"type": "foreignKey",
"editable": true,
"format": "int"
},
"contract_type_id": {
"label": "Contract Type",
"type": "Collection",
"identifier": "contract_type",
"input_type": "multi_select",
"editable": true,
"format": "int"
},
"employment_type": {
"label": "Employment Type",
"type": "integer",
"editable": true,
"enum": [
1,
2,
3
],
"valueMapping": {
"1": "Flexible",
"2": "Fixed",
"3": "External"
},
"format": "int"
},
"created_at": {
"label": "Created on Date-Time",
"editable": false,
"description": "The date the employee was created in the system.",
"type": "string",
"format": "date-time"
},
"updated_at": {
"label": "Updated on Date-Time",
"editable": false,
"description": "The date the employee was last updated in the system.",
"type": "string",
"format": "date-time"
},
"reminded_at": {
"label": "Reminded on Date-Time",
"editable": false,
"description": "The date the employee was last reminded to complete the recruiting process.",
"type": "string",
"format": "date-time"
},
"last_logged_in_at": {
"label": "Logged in on Date-Time",
"editable": false,
"description": "The date the employee was last logged in on.",
"type": "string",
"format": "date-time"
},
"last_active_at": {
"label": "Last active on Date-Time",
"editable": false,
"description": "The date the employee was last active on.",
"type": "string",
"format": "date-time"
},
"activated_at": {
"label": "Activated on Date-Time",
"editable": false,
"description": "The date the employee was activated on.",
"type": "string",
"format": "date-time"
},
"deactivated_at": {
"label": "Deactivated on Date-Time",
"editable": false,
"description": "The date the employee was deactivated on.",
"type": "string",
"format": "date-time"
},
"password_expires_at": {
"label": "Password expires at Date-Time",
"editable": false,
"description": "The date when the employee password will expire.",
"type": "string",
"format": "date-time"
},
"employee_tags": {
"label": "Tags",
"editable": false,
"type": "array",
"format": "array"
},
"employee_notes": {
"label": "Employee Notes",
"editable": false,
"type": "string"
},
"firstname": {
"label": "First name",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 1,
"input_type": "text"
},
"lastname": {
"label": "Last name",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 2,
"input_type": "text"
},
"email": {
"label": "Email address",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 3,
"input_type": "email"
},
"mobile": {
"label": "Mobile number",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 4,
"input_type": "phone"
},
"address_first": {
"label": "Street ",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 5,
"input_type": "text"
},
"address_second": {
"label": "Address line 2",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 6,
"input_type": "text"
},
"zip": {
"label": "Postcode",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 7,
"input_type": "text"
},
"city": {
"label": "City",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 8,
"input_type": "text"
},
"country": {
"label": "Country",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 9,
"input_type": "select"
},
"qualifications": {
"label": "Qualifications",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 10,
"input_type": "multi_select"
},
"dynamic_field_26": {
"label": "Applies for",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 26,
"input_type": "select"
},
"dynamic_field_27": {
"label": "How did you hear about us?",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 27,
"input_type": "multi_select"
},
"dynamic_field_28": {
"label": "Height",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 28,
"input_type": "number",
"format": "formatted-number"
},
"dynamic_field_30": {
"label": "E-Mail Sprache",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 30,
"input_type": "select"
},
"dynamic_field_31": {
"label": "Driver",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 31,
"input_type": "select"
},
"dynamic_field_32": {
"label": "Car",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 32,
"input_type": "select"
},
"dynamic_field_33": {
"label": "Gesundheitszeugnis",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 33,
"input_type": "select"
},
"dynamic_field_34": {
"label": "NI Number",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 34,
"input_type": "text"
},
"dynamic_field_38": {
"label": "IBAN",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 38,
"input_type": "text"
},
"dynamic_field_39": {
"label": "Bank",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 39,
"input_type": "text"
},
"dynamic_field_41": {
"label": "Religious denomination",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 41,
"input_type": "select"
},
"dynamic_field_43": {
"label": "Driver's licence",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 43,
"input_type": "multi_select"
},
"birthday": {
"label": "Birthday",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 47,
"input_type": "date",
"format": "formatted-date"
},
"dynamic_field_48": {
"label": "Employment Contract",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 48,
"input_type": "file"
},
"dynamic_field_49": {
"label": "Visa",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 49,
"input_type": "file"
},
"gender": {
"label": "Gender",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 51,
"input_type": "select"
},
"dynamic_field_54": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 54,
"input_type": "file"
},
"dynamic_field_62": {
"label": "Document 3",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 62,
"input_type": "file"
},
"dynamic_field_63": {
"label": "Photo 1",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 63,
"input_type": "file"
},
"dynamic_field_66": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 66,
"input_type": "level_select"
},
"dynamic_field_69": {
"label": "Ich akzeptiere die AGB",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 69,
"input_type": "boolean"
},
"dynamic_field_72": {
"label": "Employment type",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 72,
"input_type": "select"
},
"dynamic_field_73": {
"label": "Expiry date Student card",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 73,
"input_type": "date",
"format": "formatted-date"
},
"dynamic_field_74": {
"label": "DIAS number",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 74,
"input_type": "number",
"format": "formatted-number"
},
"dynamic_field_75": {
"label": "Languages",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 75,
"input_type": "level_select"
},
"dynamic_field_76": {
"label": "Date",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 76,
"input_type": "date",
"format": "formatted-date"
},
"dynamic_field_77": {
"label": "Account Balance",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 77,
"input_type": "money",
"format": "formatted-currency"
},
"dynamic_field_80": {
"label": "Validatione Grande",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 80,
"input_type": "text"
},
"dynamic_field_81": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 81,
"input_type": "file"
},
"dynamic_field_83": {
"label": "Afbeelding badge",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 83,
"input_type": "file"
},
"dynamic_field_84": {
"label": "Datum Badge",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 84,
"input_type": "date",
"format": "formatted-date"
},
"dynamic_field_87": {
"label": "EMP ID",
"description": "",
"editable": false,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 87,
"input_type": "index",
"format": "int"
},
"dynamic_field_90": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 90,
"input_type": "wysiwyg"
},
"dynamic_field_91": {
"label": "Nationality",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 91,
"input_type": "select"
},
"dynamic_field_92": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 92,
"input_type": "boolean"
},
"dynamic_field_93": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 93,
"input_type": "boolean"
},
"dynamic_field_94": {
"label": "T-Shirt size",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 94,
"input_type": "select"
},
"dynamic_field_95": {
"label": "Railcard",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 95,
"input_type": "select"
},
"dynamic_field_97": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 97,
"input_type": "number",
"format": "formatted-number"
},
"dynamic_field_98": {
"label": "Profession",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 98,
"input_type": "text"
},
"dynamic_field_99": {
"label": "Landline",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 99,
"input_type": "number",
"format": "formatted-number"
},
"dynamic_field_100": {
"label": "Marital status",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 100,
"input_type": "select"
},
"dynamic_field_101": {
"label": "Work team",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 101,
"input_type": "multi_select"
},
"dynamic_field_102": {
"label": "Visible tattoos?",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 102,
"input_type": "select"
},
"dynamic_field_103": {
"label": "Trouser size",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 103,
"input_type": "select"
},
"dynamic_field_104": {
"label": "CV",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 104,
"input_type": "file"
},
"dynamic_field_107": {
"label": "Assignments",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 107,
"input_type": "select"
},
"dynamic_field_108": {
"label": "Other languages",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 108,
"input_type": "text_area"
},
"dynamic_field_111": {
"label": "Collectionfield",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 111,
"input_type": "select"
},
"dynamic_field_114": {
"label": "Remarks",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 114,
"input_type": "text_area"
},
"dynamic_field_115": {
"label": "Driving Licence Copy",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 115,
"input_type": "file"
},
"dynamic_field_118": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 118,
"input_type": "text"
},
"dynamic_field_119": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 119,
"input_type": "select"
},
"dynamic_field_120": {
"label": "Preferred locations",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 120,
"input_type": "multi_select"
},
"dynamic_field_130": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 130,
"input_type": "multi_select"
},
"dynamic_field_131": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 131,
"input_type": "select"
},
"dynamic_field_132": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 132,
"input_type": "url"
},
"dynamic_field_134": {
"label": "This is a checkbox",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 134,
"input_type": "boolean"
},
"dynamic_field_135": {
"label": "Date",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 135,
"input_type": "date",
"format": "formatted-date"
},
"dynamic_field_136": {
"label": "Lieblingsfarbe",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 136,
"input_type": "color"
},
"dynamic_field_137": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 137,
"input_type": "datetime",
"format": "formatted-datetime"
},
"dynamic_field_138": {
"label": "decimal",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 138,
"input_type": "decimal"
},
"dynamic_field_139": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
"fieldType": "dynamicAttribute",
"attributeId": 139,
"input_type": "url"
},
"dynamic_field_140": {
"label": "",
"description": "",
"editable": true,
"dynamicField": true,
[...]
